package org.geekfu.hippo;

import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.net.URL;
import java.net.URLConnection;

import javax.swing.JApplet;

import org.mozilla.javascript.Context;
import org.mozilla.javascript.Scriptable;
import org.mozilla.javascript.ScriptableObject;

public class HippoMain extends JApplet{
	private static JApplet applet;
	private Scriptable scope;
	
	public static void main(String[] args) throws Exception{
		new HippoMain();
		Context ctx=Utils.getContext();
		reset(ctx, null);
	}

	public void start(){
		setApplet(this);
		Scriptable scope;
		try {
			scope = initHippoObjects();
			this.scope=scope;
			Context ctx=Utils.getContext();
			
			scope.put("_System", scope, ctx.newObject(scope, "System"));
			Scriptable window=ctx.newObject(scope, "GameWindow", new Object[]{this});
			
			scope.put("Window", scope, window);
			
			URL file=new URL(getCodeBase()+"/"+getParameter("source"));
			URLConnection conn=file.openConnection();
			conn.setDoInput(true);
			conn.setUseCaches(false);
			
			Reader reader=new InputStreamReader(conn.getInputStream());
			ctx.evaluateReader(scope, reader, "", 1, null);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		
	}
	
	public HippoMain() throws Exception{
	}

	public static void reset(Context ctx, Scriptable window) throws Exception {
		setApplet(null);
		Scriptable scope=initHippoObjects();
		
		if(window==null){
			window=ctx.newObject(scope, "GameWindow");
		}
		
		scope.put("Window", scope, window);
	}
	
	private static Scriptable initHippoObjects() throws Exception{
		Context ctx=Utils.getContext();
		
		InputStream str=HippoMain.class.getResourceAsStream("/org/geekfu/hippo/system.js");
		
		Reader reader=new InputStreamReader(str);

		Scriptable scope=ctx.initStandardObjects();

		ScriptableObject.defineClass(scope, HostGameWindow.class);
		ScriptableObject.defineClass(scope, HostMap.class);
		ScriptableObject.defineClass(scope, HostSidebar.class);
		ScriptableObject.defineClass(scope, HostItemList.class);
		ScriptableObject.defineClass(scope, HostPiece.class);
		ScriptableObject.defineClass(scope, HostSystem.class);

		scope.put("_System", scope, ctx.newObject(scope, "System"));

		ctx.evaluateReader(scope, reader, "", 1, null);
		
		return scope;
	}

	public static boolean isApplet() {
		return applet!=null;
	}
	
	public static JApplet getApplet(){
		return applet;
	}

	public static void setApplet(JApplet applet) {
		HippoMain.applet = applet;
	}
	
	public void eval(String str){
		Context ctx=Utils.getContext();
		ctx.evaluateString(scope, str, "fromPage", 1, null);
	}
}
