package org.geekfu.hippo;

import org.mozilla.javascript.Scriptable;
import org.mozilla.javascript.ScriptableObject;

public class HostItemList extends ScriptableObject{

	private ItemList itemList;
	private boolean live=true;
	
	@Override
	public String getClassName() {
		return "ItemList";
	}

	public void jsConstructor(){
		itemList=new ItemList();
		defineProperty("cellsize",this.getClass(),ScriptableObject.PERMANENT);
		defineProperty("live",this.getClass(),ScriptableObject.PERMANENT);
		defineProperty("length",this.getClass(),ScriptableObject.READONLY);
		defineFunctionProperties(new String[]{"repaint"}, this.getClass(), ScriptableObject.PERMANENT);
	}

	public ItemList getItemList() {
		return itemList;
	}
	
	@Override
	public void put(int idx, Scriptable scope, Object obj) {
		super.put(idx,scope,obj);
		if(obj instanceof ScriptableObject){
			itemList.putItem(idx,(ScriptableObject) obj);
			if(live)itemList.refresh();
		}else{
			itemList.removeItem(idx);
			if(live)itemList.refresh();
		}
	}
	
	public Object get(int idx, Scriptable scope){
		return itemList.getItem(idx);
	}
	
	public void repaint(){
		itemList.refresh();
	}
	
	public int getCellsize(){return itemList.getCellsize();}
	public void setCellsize(int cellsize){
		itemList.setCellsize(cellsize);
		if(live)itemList.refresh();
	}

	public boolean getLive() {
		return live;
	}

	public void setLive(boolean live) {
		this.live = live;
	}
	
	public int getLength() {
		return itemList.getLength();
	}

}
