package org.geekfu.hippo;

import java.awt.Color;
import java.util.Set;

import org.mozilla.javascript.Context;
import org.mozilla.javascript.Scriptable;
import org.mozilla.javascript.ScriptableObject;

public class Utils {
	public static Color getColor(Object obj) {
		if(obj==null)return Color.black;
		String ret=obj.toString();
		ret=ret.toLowerCase();

		if(ret.equals("black"))return Color.BLACK;
		else if(ret.equals("red"))return Color.RED;
		else if(ret.equals("yellow"))return Color.yellow;
		else if(ret.equals("green"))return Color.green;
		else if(ret.equals("blue"))return Color.blue;
		else if(ret.equals("white"))return Color.white;
		else if(ret.equals("gray"))return Color.gray;
		else if(ret.equals("orange"))return Color.orange;
		else if(ret.equals("purple"))return Color.magenta;

		return Color.black;
	}
	
	public static GenericObject createObj(String name){
		return new GenericObject(name,null);
	}
	
	public static GenericObject createObj(){
		return new GenericObject("UnspecifiedType",null);
	}

	public static GenericObject createObj(String name,Notifiable parent){
		return new GenericObject(name,parent);
	}
	
	public static GenericObject createObj(Notifiable parent){
		return new GenericObject("UnspecifiedType",parent);
	}

	public static class GenericObject extends ScriptableObject{
		private String name;
		private Notifiable parent;
		private boolean suspendNotify=false;
		public GenericObject(String name,Notifiable parent){
			this.name=name;
			this.parent=parent;
		}
		public String getClassName() {return name;}
		public void put(int index,Scriptable start,Object value){
			super.put(index, start, value);
			if(parent!=null && !suspendNotify)parent.notify(this);
		}
		public void putNoNotify(int index,Scriptable start,Object value){
			super.put(index, start, value);
		}
		public void put(String name,Scriptable start,Object value){
			super.put(name, start, value);
			if(parent!=null && !suspendNotify)parent.notify(this);
		}
		public void putNoNotify(String name,Scriptable start,Object value){
			super.put(name, start, value);
		}
		public void suspendNotify(boolean suspendNotify) {this.suspendNotify = suspendNotify;}
	}
	
	public static String unique(String base, Set<String> others){
		if(!others.contains(base))return base;
		int suffix=1;
		while(others.contains(base+"-"+suffix))suffix++;
		return base+"-"+suffix;
	}
	
	public static Context getContext(){
		Context ctx=Context.enter();
		if(HippoMain.isApplet())ctx.setOptimizationLevel(-1);
		return ctx;
	}
}
