package org.geekfu.Cartographer;

import java.awt.Graphics;
import java.awt.Image;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;

import javax.imageio.ImageIO;

public class ImageCell extends MapCell {
	private Image image; // The image to use for this cell
	
	private ImageCell() {}
	
	public ImageCell(InputStream input) {
		try {
			image=ImageIO.read(input);
		} catch (IOException exc) {
			exc.printStackTrace();
		}
	}
	
	public ImageCell(String filename) {
		try {
			image=ImageIO.read(new FileInputStream(filename));
		} catch (FileNotFoundException exc) {
			exc.printStackTrace();
		} catch (IOException exc) {
			exc.printStackTrace();
		}
	}
	
	public ImageCell(Image image) {
		this.image=image;
	}
	
	@Override
	public void repaint() {
		Graphics g=getCanvas().getGraphics();
		if(image!=null)
			g.drawImage(image,0,0,null);
	}
		
	public void setImage(Image image) {
		this.image = image;
	}
}
